# Python SDK

### Objective

This SDK is designed to make it easy for you to use the bloXroute Labs API in Python.

[Source](https://github.com/bloXroute-Labs/serum-client-python)

### Installation

```
$ pip install bxsolana-trader
```

### Usage

This library supports HTTP, websockets, and GRPC interfaces. You can use it with a context manager or handle open/closing yourself.

For any methods involving transaction creation you will need to provide your Solana private key. You can provide this via the environment variable `PRIVATE_KEY`, or specify it via the provider configuration if you want to load it with some other mechanism. See samples for more information. As a general note on this: methods named `post_*` (e.g. `post_order`) typically do not sign/submit the transaction, only return the raw unsigned transaction. This isn't very useful to most users (unless you want to write a signer in a different language), and you'll typically want the similarly named `submit_*` methods (e.g. `submit_order`). These methods generate, sign, and submit the transaction all at once.

You will also need your bloXroute authorization header to use these endpoints. By default, this is loaded from the `AUTH_HEADER` environment variable.

**Context manager:**

```python
from bxsolana import provider

async with provider.http() as api:
    print(await api.get_orderbook(market="ETHUSDT"))
    
async with provider.ws() as api:
    async for update in api.get_orderbooks_stream(market="ETHUSDT"):
        print(update)
```

**Manual**:

```python
import bxsolana

from bxsolana import provider

p = provider.grpc()
api = await bxsolana.trader_api(p)

try:
    await api.get_orderbook(market="ETHUSDT")
finally:
    await p.close()
```

Refer to the `examples/` for more info.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bloxroute.com/solana/trader-api/quick-start/python-sdk.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
